routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get("/","Auth@index")->name("login");
Route::get("/template",function (){
    return view("template.jadwal");
});
Route::post("/login","Auth@login")->name("login.post");
Route::get("/logout","Auth@logout")->name("login");
Route::prefix("/template")->name("template.")->group(function (){
    Route::get("/ruangan","Utility@excel_template_ruangan")->name("ruangan");
    Route::get("/dosen","Utility@excel_template_dosen")->name("dosen");
    Route::get("/mahasiswa","Utility@excel_template_mahasiswa")->name("mahasiswa");
    Route::get("/sekretariat","Utility@excel_template_sekretariat")->name("sekretariat");
    Route::get("/seminar","Utility@excel_template_seminar")->name("seminar");
    Route::get("/sidang","Utility@excel_template_sidang")->name("sidang");
});

Route::get("/dashboard","Dashboard@index")->middleware("gateway:0|1|2|3")->name("dashboard");
//Admin
Route::prefix("master")->middleware("gateway:0")->name("master.")->namespace("Master")->group(function(){
    Route::prefix("ruangan")->name("ruangan.")->group(function (){
        Route::get("/","Ruangan@index")->name("list");

        Route::get("/add","Ruangan@add")->name("add");
        Route::post("/add","Ruangan@add_action")->name("add.action");

        Route::get("/update/{id}","Ruangan@update")->name("update");
        Route::post("/update/{id}","Ruangan@update_action")->name("update.action");

        Route::get("/delete/{id}","Ruangan@delete")->name("delete");
    });

    Route::prefix("dosen")->name("dosen.")->group(function (){
        Route::get("/","Dosen@index")->name("list");

        Route::get("/add","Dosen@add")->name("add");
        Route::post("/add","Dosen@add_action")->name("add.action");

        Route::get("/update/{id}","Dosen@update")->name("update");
        Route::post("/update/{id}","Dosen@update_action")->name("update.action");

        Route::get("/delete/{id}","Dosen@delete")->name("delete");
    });

    Route::prefix("mahasiswa")->name("mahasiswa.")->group(function (){
        Route::get("/","Mahasiswa@index")->name("list");

        Route::get("/add","Mahasiswa@add")->name("add");
        Route::post("/add","Mahasiswa@add_action")->name("add.action");

        Route::get("/update/{id}","Mahasiswa@update")->name("update");
        Route::post("/update/{id}","Mahasiswa@update_action")->name("update.action");

        Route::get("/delete/{id}","Mahasiswa@delete")->name("delete");
    });

    Route::prefix("sekretariat")->name("sekretariat.")->group(function (){
        Route::get("/","Sekretariat@index")->name("list");

        Route::get("/add","Sekretariat@add")->name("add");
        Route::post("/add","Sekretariat@add_action")->name("add.action");

        Route::get("/update/{id}","Sekretariat@update")->name("update");
        Route::post("/update/{id}","Sekretariat@update_action")->name("update.action");

        Route::get("/delete/{id}","Sekretariat@delete")->name("delete");
    });

    Route::prefix("administrator")->name("administrator.")->group(function (){
        Route::get("/","Administrator@index")->name("list");

        Route::get("/add","Administrator@add")->name("add");
        Route::post("/add","Administrator@add_action")->name("add.action");

        Route::get("/update/{id}","Administrator@update")->name("update");
        Route::post("/update/{id}","Administrator@update_action")->name("update.action");

        Route::get("/delete/{id}","Administrator@delete")->name("delete");
    });
});
//Sekretariat


Route::prefix("penguji")->middleware("gateway:1")->name("penguji.")->namespace("Penjadwalan")->group(function (){
    Route::get("/","Penguji@index")->name("list");

    Route::get("/add","Penguji@add")->name("add");
    Route::post("/add","Penguji@add_action")->name("add.action");

    Route::get("/update/{id}","Penguji@update")->name("update");
    Route::post("/update/{id}","Penguji@update_action")->name("update.action");

    Route::get("/delete/{id}","Penguji@delete")->name("delete");
});

Route::prefix("seminar")->middleware("gateway:1")->name("seminar.")->namespace("Penjadwalan")->group(function (){
    Route::get("/","Seminar@index")->name("list");

    Route::get("/add","Seminar@add")->name("add");
    Route::post("/add","Seminar@add_action")->name("add.action");

    Route::get("/update/{id}","Seminar@update")->name("update");
    Route::post("/update/{id}","Seminar@update_action")->name("update.action");

    Route::get("/delete/{id}","Seminar@delete")->name("delete");

    Route::get("/view","Seminar@view")->name("view");
    Route::get("/config","Seminar@configView")->name("view.config");
    Route::get("/update_status","Seminar@updateStatus")->name("config.update_status");
});


Route::prefix("sidang")->middleware("gateway:1")->name("sidang.")->namespace("Penjadwalan")->group(function (){
    Route::get("/","Sidang@index")->name("list");

    Route::get("/add","Sidang@add")->name("add");
    Route::post("/add","Sidang@add_action")->name("add.action");

    Route::get("/update/{id}","Sidang@update")->name("update");
    Route::post("/update/{id}","Sidang@update_action")->name("update.action");

    Route::get("/delete/{id}","Sidang@delete")->name("delete");

    Route::get("/view","Sidang@view")->name("view");
    Route::get("/config","Sidang@configView")->name("view.config");
    Route::get("/update_status","Sidang@updateStatus")->name("config.update_status");
});
//Siswa
Route::prefix("jadwal")->middleware("gateway:2|3")->namespace("Jadwal")->name("jadwal.")->group(function (){
    Route::get("/","Penjadwalan@index")->name("list");
});



Route::prefix("cetak")->middleware("gateway:1")->namespace("Cetak")->name("cetak")->group(function(){
    Route::get("/","Cetak@index")->name("list");
    Route::get("/jadwal","Cetak@jadwal")->name("jadwal");

});

app/Http/Controllers/Master/Dosen.php
<?php

namespace App\Http\Controllers\Master;

use App\Casts\LevelAccount;
use App\Http\Controllers\Controller;
use App\Models\Handler;
use App\Models\Room;
use App\Models\User;
use App\Traits\ViewTrait;
use Igun997\Utility\Excel;
use Illuminate\Http\Request;

class Dosen extends Controller
{
    use ViewTrait;
    public function __construct()
    {
        $this->base = "master.dosen";
    }

    /**
     * @param Request $req
     * @return mixed
     */
    public function index(Request $req)
    {
        $data = [
            "title"=>"Data Dosen",
            "data"=>Handler::all()
        ];
        return  $this->loadView("index",$data);
    }

    /**
     * @return mixed
     */
    public function add()
    {
        $data = [
            "title"=>"Tambah Dosen",
            "route"=>route("master.dosen.add.action")
        ];

        return $this->loadView("form",$data);

    }

    /**
     * @param Request $req
     * @return mixed
     */
    public function add_action(Request $req)
    {
        if (!$req->has("file")){
            $req->validate([
                "nip"=>"required|unique:handlers,nip",
                "name"=>"required",
                "kelas"=>"min:1",
                "semester"=>"min:1",
            ]);
            User::create(["name"=>$req->name,"username"=>$req->nip,"password"=>$req->nip,"status"=>1,"level"=>LevelAccount::DOSEN]);
            $create = Handler::create($req->all());
        }else{
            $create = false;
            $file = $req->file("file");
            $store = $file->store("temp");
            $valid = storage_path()."/app/".$store;
            $excel = new Excel($valid);
            $format = [
                "nip"=>"nip",
                "nama"=>"nama",
                "kelas"=>"kelas",
                "semester"=>"semester",
            ];
            $result_excel = $excel->type("array")->setLabel(1)->reformat($format)->output();
            $unique = [];
            foreach ($result_excel as $index => $item) {
                if ($item["nip"] !== null){
                    $item["name"] = $item["nama"];
                    $unique[] = $item;
                }
            }
            $uniques = array_unique($unique);
            $itemSave = [];
            foreach ($uniques as $index => $unique) {
                $find = Handler::where(["nip"=>$unique["nip"]])->count();
                if ($find === 0){
                    $base = $unique;
                    User::create(["name"=>$base["name"],"username"=>$base["nip"],"password"=>$base["nip"],"status"=>1,"level"=>LevelAccount::DOSEN]);
                    $save = Handler::create($base);
                    if ($save){
                        $itemSave[] = 1;
                    }else{
                        $itemSave[] = 0;
                    }
                }
            }

            if (count(array_unique($itemSave)) === 1){
                return $this->successBack();
            }
            return $this->failBack();
        }

        if ($create){
            return $this->successRedirect("master.dosen.list");
        }
        return $this->failBack();
    }

    /**
     * @param Request $req
     * @param $id
     * @return mixed
     */
    public function update(Request $req, $id)
    {
        $dosen = Handler::findOrFail($id);
        $data = [
            "title"=>"Update Dosen",
            "data"=>$dosen,
            "route"=>route("master.dosen.update.action",$id)
        ];

        return $this->loadView("form",$data);
    }

    /**
     * @param Request $req
     * @param $id
     * @return mixed
     */
    public function update_action(Request $req, $id)
    {
        $req->validate([
            "name"=>"required",
        ]);

        $dosen = Handler::findOrFail($id);
        $dosen->name = $req->name;
        if($req->has("semester") && $req->has("kelas")){
            $dosen->kelas = $req->kelas;
            $dosen->semester = $req->semester;
        }
        if ($req->has("nip")){
            $dosen->nip = $req->nip;
        }
        if ($dosen->save()){
            return $this->successRedirect("master.dosen.list",false);
        }
        return $this->failBack(false);
    }

    /**
     * @param $id
     * @return mixed
     */
    public function delete($id)
    {
        $dosen = Handler::findOrFail($id);
        $del = $dosen->delete();
        if ($del){
            return $this->successBack(false);
        }
        return $this->failBack(false);

    }

}

app/Http/Controllers/Master/Mahasiswa.php
<?php

namespace App\Http\Controllers\Master;

use App\Casts\LevelAccount;
use App\Casts\StatusAccount;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Traits\ViewTrait;
use Igun997\Utility\Excel;
use Illuminate\Http\Request;

class Mahasiswa extends Controller
{
    use ViewTrait;
    public function __construct()
    {
        $this->base = "master.mahasiswa";
    }

    /**
     * @param Request $req
     * @return mixed
     */
    public function index(Request $req)
    {
        $data = [
            "title"=>"Data Mahasiswa",
            "data"=>User::where(["level"=>LevelAccount::MAHASISWA])->get()
        ];
        return  $this->loadView("index",$data);
    }

    /**
     * @return mixed
     */
    public function add()
    {
        $data = [
            "title"=>"Tambah Mahasiswa",
            "route"=>route("master.mahasiswa.add.action")
        ];

        return $this->loadView("form",$data);

    }

    /**
     * @param Request $req
     * @return mixed
     */
    public function add_action(Request $req)
    {
        if (!$req->has("file")){
            $req->validate([
                "username"=>"required|unique:users,username",
                "name"=>"required",
                "kelas"=>"required",
                "semester"=>"required",
                "password"=>"required",
            ]);
            $data = $req->all();
            $data["kelas"] = strtoupper($data["kelas"]);
            $data["semester"] = strtoupper($data["semester"]);
            $data["status"] = StatusAccount::ACTIVE;
            $data["level"] = LevelAccount::MAHASISWA;
            $create = User::create($data);
        }else{
            $create = false;
            $file = $req->file("file");
            $store = $file->store("temp");
            $valid = storage_path()."/app/".$store;
            $excel = new Excel($valid);
            $format = [
                "nim"=>"nim",
                "nama"=>"nama",
                "kelas"=>"kelas",
                "semester"=>"semester",
                "password"=>"password",
            ];
            $result_excel = $excel->type("array")->setLabel(1)->reformat($format)->output();
            $unique = [];
            foreach ($result_excel as $index => $item) {
                if ($item["nim"] !== null && $item["semester"] !== null && $item["kelas"] !== null){
                    $item["name"] = $item["nama"];
                    $item["username"] = $item["nim"];
                    if (!$item["password"]){
                        $item["password"] = $item["nim"];
                    }
                    $unique[] = $item;
                }
            }
            $uniques = array_map("unserialize", array_unique(array_map("serialize", $unique)));
            $itemSave = [];
            foreach ($uniques as $index => $unique) {
                $find = User::where(["username"=>$unique["nim"]])->count();
                if ($find === 0){
                    $base = $unique;

                    $base["status"] = StatusAccount::ACTIVE;
                    $base["level"] = LevelAccount::MAHASISWA;
                    $save = User::create($base);
                    if ($save){
                        $itemSave[] = 1;
                    }else{
                        $itemSave[] = 0;
                    }
                }
            }

            if (count(array_unique($itemSave)) === 1){
                return $this->successBack();
            }
            return $this->failBack();
        }

        if ($create){
            return $this->successRedirect("master.mahasiswa.list");
        }
        return $this->failBack();
    }

    /**
     * @param Request $req
     * @param $id
     * @return mixed
     */
    public function update(Request $req, $id)
    {
        $Mahasiswa = User::findOrFail($id);
        $data = [
            "title"=>"Update Mahasiswa",
            "data"=>$Mahasiswa,
            "route"=>route("master.mahasiswa.update.action",$id)
        ];

        return $this->loadView("form",$data);
    }

    /**
     * @param Request $req
     * @param $id
     * @return mixed
     */
    public function update_action(Request $req, $id)
    {
        $req->validate([
            "name"=>"required",
            "status"=>"required",
            "password"=>"min:3",
        ]);

        $Mahasiswa = User::findOrFail($id);
        $Mahasiswa->name = $req->name;
        $Mahasiswa->status = $req->status;
        $Mahasiswa->kelas = $req->kelas;
        $Mahasiswa->semester = $req->semester;
        if ($req->has("password")){
            $Mahasiswa->password = $req->password;
        }
        if ($Mahasiswa->save()){
            return $this->successRedirect("master.mahasiswa.list",false);
        }
        return $this->failBack(false);
    }

    /**
     * @param $id
     * @return mixed
     */
    public function delete($id)
    {
        $Mahasiswa = User::findOrFail($id);
        $del = $Mahasiswa->delete();
        if ($del){
            return $this->successBack(false);
        }
        return $this->failBack(false);

    }

}

resources/views/master/sekretariat/form.blade.php
@extends('adminlte::page')

@section('title', ((isset($title))?$title:""))

@section('content_header')

@stop

@section('content')
    <div class="row">
        <div class="col-6 offset-3">
            <div class="card">
                <div class="card-header">
                    <div class="card-title">{{((isset($title))?$title:"")}}</div>
                </div>
                <div class="card-body">
                    <form action="{{$route}}" method="post">
                        <div class="form-group">
                            <label>Username</label>
                            <input type="text" class="form-control" name="username" {{(isset($data->username))?"disabled":""}} value="{{@$data->username}}" required>
                        </div>
                        <div class="form-group">
                            <label>Nama Sekretariat</label>
                            <input type="text" class="form-control" name="name"  value="{{@$data->name}}" required>
                        </div>
                        <div class="form-group">
                            <label>Password</label>
                            <input type="password" class="form-control" name="password"  value="{{@$data->password}}" required>
                        </div>
                        <div class="form-group">
                            <label>Aktif ? </label>
                            <select name="status" class="form-control" >
                                <option value="1" {{(@$data->status == 1)?"selected":""}}>Aktif</option>
                                <option value="0" {{(@$data->status == 0)?"selected":""}}>Tidak Aktif</option>
                            </select>
                        </div>
                        <div class="form-group">
                            <button class="btn btn-primary btn-block btn-lg">Simpan Data</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')

@stop

@section("js")
    @include("msg")
    <script>

    </script>
@stop

resources/views/master/sekretariat/index.blade.php
@extends('adminlte::page')

@section('title', ((isset($title))?$title:""))

@section('content_header')

@stop

@section('content')
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <div class="card-title">{{((isset($title))?$title:"")}}</div>
                </div>
                <div class="card-body">
                    <a href="{{route("master.sekretariat.add")}}" class="btn btn-success ml-2 mb-4">
                        <li class="fa fa-plus"></li> Tambah Data
                    </a>
                    <button id="import" type="button" class="btn btn-primary ml-2 mb-4">
                        <li class="fa fa-upload"></li> Upload via Excel
                    </button>
                    <a href="{{route("template.sekretariat")}}" class="btn btn-primary ml-2 mb-4">
                        <li class="fa fa-download"></li> Template Excel
                    </a>
                    <div class="table-responsive">
                        <table id="sekretariat" class="table table-bordered">
                            <thead>
                                <tr>
                                    <th>No</th>
                                    <th>Username</th>
                                    <th>Nama</th>
                                    <th>Status</th>
                                    <th>Dibuat</th>
                                    <th>Diubah</th>
                                    <th>Aksi</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($data as $num => $row)
                                    <tr>
                                        <td>{{($num+1)}}</td>
                                        <td>{{$row->username}}</td>
                                        <td>{{$row->name}}</td>
                                        <td>{{\App\Casts\StatusAccount::lang($row->status)}}</td>
                                        <td>{{$row->created_at->format("d-m-Y")}}</td>
                                        <td>{{$row->updated_at->format("d-m-Y")}}</td>
                                        <td>
                                            <a href="{{route("master.sekretariat.update",$row->id)}}" class="btn btn-warning m-2">
                                                <li class="fa fa-edit"></li>
                                            </a>

                                            <a href="{{route("master.sekretariat.delete",$row->id)}}" class="btn btn-danger m-2">
                                                <li class="fa fa-trash"></li>
                                            </a>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')

@stop

@section("js")
    @include("msg")
    <script>
        $(document).ready(function () {
            $("#sekretariat").DataTable();
            $("#import").on("click",function () {
                var dialog = bootbox.dialog({
                    title: 'Upload Data',
                    message: '<p align="center"><i class="fa fa-spin fa-spinner"></i> Loading...</p>'
                });

                dialog.init(function(){
                    setTimeout(function(){
                        var form = [
                            "<form action='{{route("master.sekretariat.add.action")}}' method='post' enctype='multipart/form-data'>",
                            "<div class='form-group'>",
                            "<label>Masukan File Excel</label>",
                            "<input type='file' name='file' accept='application/vnd.ms-excel' class='form-control' required>",
                            "</div>",
                            "<div class='form-group'>",
                            "<button type='submit' class='btn btn-success'>Upload</button>",
                            "</div>",
                            "</form>"
                        ]
                        dialog.find('.bootbox-body').html(form.join(""));
                    }, 100);
                });
            })
        });
    </script>
@stop